/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.0</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.9.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Provides detailed information about a process executed by a command step.
 */
@ApiModel(description = "Provides detailed information about a process executed by a command step.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2022-12-13T13:57:16.085Z")
public class ApiCommandStepProcess {
  @SerializedName("name")
  private String name = null;

  @SerializedName("id")
  private java.math.BigDecimal id = null;

  @SerializedName("program")
  private String program = null;

  @SerializedName("args")
  private String args = null;

  @SerializedName("stdout")
  private String stdout = null;

  @SerializedName("stderr")
  private String stderr = null;

  @SerializedName("exitCode")
  private java.math.BigDecimal exitCode = null;

  public ApiCommandStepProcess name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the command step process.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the command step process.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ApiCommandStepProcess id(java.math.BigDecimal id) {
    this.id = id;
    return this;
  }

   /**
   * Id of the command step process.
   * @return id
  **/
  @ApiModelProperty(value = "Id of the command step process.")
  public java.math.BigDecimal getId() {
    return id;
  }

  public void setId(java.math.BigDecimal id) {
    this.id = id;
  }

  public ApiCommandStepProcess program(String program) {
    this.program = program;
    return this;
  }

   /**
   * The executed program command.
   * @return program
  **/
  @ApiModelProperty(value = "The executed program command.")
  public String getProgram() {
    return program;
  }

  public void setProgram(String program) {
    this.program = program;
  }

  public ApiCommandStepProcess args(String args) {
    this.args = args;
    return this;
  }

   /**
   * JSON-encoded list of program arguments.
   * @return args
  **/
  @ApiModelProperty(value = "JSON-encoded list of program arguments.")
  public String getArgs() {
    return args;
  }

  public void setArgs(String args) {
    this.args = args;
  }

  public ApiCommandStepProcess stdout(String stdout) {
    this.stdout = stdout;
    return this;
  }

   /**
   * Last lines of the executed program&#39;s standard output.
   * @return stdout
  **/
  @ApiModelProperty(value = "Last lines of the executed program's standard output.")
  public String getStdout() {
    return stdout;
  }

  public void setStdout(String stdout) {
    this.stdout = stdout;
  }

  public ApiCommandStepProcess stderr(String stderr) {
    this.stderr = stderr;
    return this;
  }

   /**
   * Last lines of the executed program&#39;s standard error.
   * @return stderr
  **/
  @ApiModelProperty(value = "Last lines of the executed program's standard error.")
  public String getStderr() {
    return stderr;
  }

  public void setStderr(String stderr) {
    this.stderr = stderr;
  }

  public ApiCommandStepProcess exitCode(java.math.BigDecimal exitCode) {
    this.exitCode = exitCode;
    return this;
  }

   /**
   * The executed program&#39;s exit code.
   * @return exitCode
  **/
  @ApiModelProperty(value = "The executed program's exit code.")
  public java.math.BigDecimal getExitCode() {
    return exitCode;
  }

  public void setExitCode(java.math.BigDecimal exitCode) {
    this.exitCode = exitCode;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiCommandStepProcess apiCommandStepProcess = (ApiCommandStepProcess) o;
    return Objects.equals(this.name, apiCommandStepProcess.name) &&
        Objects.equals(this.id, apiCommandStepProcess.id) &&
        Objects.equals(this.program, apiCommandStepProcess.program) &&
        Objects.equals(this.args, apiCommandStepProcess.args) &&
        Objects.equals(this.stdout, apiCommandStepProcess.stdout) &&
        Objects.equals(this.stderr, apiCommandStepProcess.stderr) &&
        Objects.equals(this.exitCode, apiCommandStepProcess.exitCode);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, id, program, args, stdout, stderr, exitCode);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiCommandStepProcess {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    program: ").append(toIndentedString(program)).append("\n");
    sb.append("    args: ").append(toIndentedString(args)).append("\n");
    sb.append("    stdout: ").append(toIndentedString(stdout)).append("\n");
    sb.append("    stderr: ").append(toIndentedString(stderr)).append("\n");
    sb.append("    exitCode: ").append(toIndentedString(exitCode)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

