/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.0</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.9.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Arguments used to install a Private Cloud Control Plane on embedded kubernetes
 */
@ApiModel(description = "Arguments used to install a Private Cloud Control Plane on embedded kubernetes")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2022-12-13T13:57:16.085Z")
public class ApiInstallEmbeddedControlPlaneArgs {
  @SerializedName("remoteRepoUrl")
  private String remoteRepoUrl = null;

  @SerializedName("valuesYaml")
  private String valuesYaml = null;

  @SerializedName("experienceClusterName")
  private String experienceClusterName = null;

  @SerializedName("containerizedClusterName")
  private String containerizedClusterName = null;

  @SerializedName("datalakeClusterName")
  private String datalakeClusterName = null;

  @SerializedName("selectedFeatures")
  private String selectedFeatures = null;

  public ApiInstallEmbeddedControlPlaneArgs remoteRepoUrl(String remoteRepoUrl) {
    this.remoteRepoUrl = remoteRepoUrl;
    return this;
  }

   /**
   * The url of the remote repository where the private cloud artifacts to install are hosted
   * @return remoteRepoUrl
  **/
  @ApiModelProperty(value = "The url of the remote repository where the private cloud artifacts to install are hosted")
  public String getRemoteRepoUrl() {
    return remoteRepoUrl;
  }

  public void setRemoteRepoUrl(String remoteRepoUrl) {
    this.remoteRepoUrl = remoteRepoUrl;
  }

  public ApiInstallEmbeddedControlPlaneArgs valuesYaml(String valuesYaml) {
    this.valuesYaml = valuesYaml;
    return this;
  }

   /**
   * A yaml file containing configuration parameters for the installation.
   * @return valuesYaml
  **/
  @ApiModelProperty(value = "A yaml file containing configuration parameters for the installation.")
  public String getValuesYaml() {
    return valuesYaml;
  }

  public void setValuesYaml(String valuesYaml) {
    this.valuesYaml = valuesYaml;
  }

  public ApiInstallEmbeddedControlPlaneArgs experienceClusterName(String experienceClusterName) {
    this.experienceClusterName = experienceClusterName;
    return this;
  }

   /**
   * Deprecated. Use containerizedClusterName instead.
   * @return experienceClusterName
  **/
  @ApiModelProperty(value = "Deprecated. Use containerizedClusterName instead.")
  public String getExperienceClusterName() {
    return experienceClusterName;
  }

  public void setExperienceClusterName(String experienceClusterName) {
    this.experienceClusterName = experienceClusterName;
  }

  public ApiInstallEmbeddedControlPlaneArgs containerizedClusterName(String containerizedClusterName) {
    this.containerizedClusterName = containerizedClusterName;
    return this;
  }

   /**
   * The name of the Containerized Cluster that will bring up this control plane
   * @return containerizedClusterName
  **/
  @ApiModelProperty(value = "The name of the Containerized Cluster that will bring up this control plane")
  public String getContainerizedClusterName() {
    return containerizedClusterName;
  }

  public void setContainerizedClusterName(String containerizedClusterName) {
    this.containerizedClusterName = containerizedClusterName;
  }

  public ApiInstallEmbeddedControlPlaneArgs datalakeClusterName(String datalakeClusterName) {
    this.datalakeClusterName = datalakeClusterName;
    return this;
  }

   /**
   * The name of the datalake cluster to use for the initial environment in this control plane
   * @return datalakeClusterName
  **/
  @ApiModelProperty(value = "The name of the datalake cluster to use for the initial environment in this control plane")
  public String getDatalakeClusterName() {
    return datalakeClusterName;
  }

  public void setDatalakeClusterName(String datalakeClusterName) {
    this.datalakeClusterName = datalakeClusterName;
  }

  public ApiInstallEmbeddedControlPlaneArgs selectedFeatures(String selectedFeatures) {
    this.selectedFeatures = selectedFeatures;
    return this;
  }

   /**
   * Optional. The name of the feature(s) in a comma separated list that container images/packages are associated with. When it is null, copy all the images.
   * @return selectedFeatures
  **/
  @ApiModelProperty(value = "Optional. The name of the feature(s) in a comma separated list that container images/packages are associated with. When it is null, copy all the images.")
  public String getSelectedFeatures() {
    return selectedFeatures;
  }

  public void setSelectedFeatures(String selectedFeatures) {
    this.selectedFeatures = selectedFeatures;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiInstallEmbeddedControlPlaneArgs apiInstallEmbeddedControlPlaneArgs = (ApiInstallEmbeddedControlPlaneArgs) o;
    return Objects.equals(this.remoteRepoUrl, apiInstallEmbeddedControlPlaneArgs.remoteRepoUrl) &&
        Objects.equals(this.valuesYaml, apiInstallEmbeddedControlPlaneArgs.valuesYaml) &&
        Objects.equals(this.experienceClusterName, apiInstallEmbeddedControlPlaneArgs.experienceClusterName) &&
        Objects.equals(this.containerizedClusterName, apiInstallEmbeddedControlPlaneArgs.containerizedClusterName) &&
        Objects.equals(this.datalakeClusterName, apiInstallEmbeddedControlPlaneArgs.datalakeClusterName) &&
        Objects.equals(this.selectedFeatures, apiInstallEmbeddedControlPlaneArgs.selectedFeatures);
  }

  @Override
  public int hashCode() {
    return Objects.hash(remoteRepoUrl, valuesYaml, experienceClusterName, containerizedClusterName, datalakeClusterName, selectedFeatures);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiInstallEmbeddedControlPlaneArgs {\n");
    
    sb.append("    remoteRepoUrl: ").append(toIndentedString(remoteRepoUrl)).append("\n");
    sb.append("    valuesYaml: ").append(toIndentedString(valuesYaml)).append("\n");
    sb.append("    experienceClusterName: ").append(toIndentedString(experienceClusterName)).append("\n");
    sb.append("    containerizedClusterName: ").append(toIndentedString(containerizedClusterName)).append("\n");
    sb.append("    datalakeClusterName: ").append(toIndentedString(datalakeClusterName)).append("\n");
    sb.append("    selectedFeatures: ").append(toIndentedString(selectedFeatures)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

