/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.0</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.9.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.cloudera.api.swagger.model.ApiRangerReplicationExportArgs;
import com.cloudera.api.swagger.model.ApiRangerReplicationImportArgs;
import com.cloudera.api.swagger.model.ApiRangerReplicationTransformArgs;
import com.cloudera.api.swagger.model.ApiServiceRef;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Replication arguments for Ranger services. It&#39;s replicated the following way: &lt;ol&gt; &lt;li&gt;EXPORT the Ranger services and policies from the source, then COPY to the destination, see available arguments in ApiRangerReplicationExportArgs&lt;/li&gt; &lt;li&gt;TRANSFORM the exported Ranger services and policies on the destination, see available arguments in ApiRangerReplicationTransformArgs&lt;/li&gt; &lt;li&gt;IMPORT the exported and transformed Ranger services to the destination Ranger service, see available arguments in ApiRangerReplicationImportArgs&lt;/li&gt; &lt;/ol&gt;
 */
@ApiModel(description = "Replication arguments for Ranger services. It's replicated the following way: <ol> <li>EXPORT the Ranger services and policies from the source, then COPY to the destination, see available arguments in ApiRangerReplicationExportArgs</li> <li>TRANSFORM the exported Ranger services and policies on the destination, see available arguments in ApiRangerReplicationTransformArgs</li> <li>IMPORT the exported and transformed Ranger services to the destination Ranger service, see available arguments in ApiRangerReplicationImportArgs</li> </ol>")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2022-12-13T13:57:16.085Z")
public class ApiRangerReplicationArgs {
  @SerializedName("sourceRangerService")
  private ApiServiceRef sourceRangerService = null;

  @SerializedName("exportArgs")
  private ApiRangerReplicationExportArgs exportArgs = null;

  @SerializedName("transformArgs")
  private ApiRangerReplicationTransformArgs transformArgs = null;

  @SerializedName("importArgs")
  private ApiRangerReplicationImportArgs importArgs = null;

  public ApiRangerReplicationArgs sourceRangerService(ApiServiceRef sourceRangerService) {
    this.sourceRangerService = sourceRangerService;
    return this;
  }

   /**
   * The source service to replicate from.
   * @return sourceRangerService
  **/
  @ApiModelProperty(value = "The source service to replicate from.")
  public ApiServiceRef getSourceRangerService() {
    return sourceRangerService;
  }

  public void setSourceRangerService(ApiServiceRef sourceRangerService) {
    this.sourceRangerService = sourceRangerService;
  }

  public ApiRangerReplicationArgs exportArgs(ApiRangerReplicationExportArgs exportArgs) {
    this.exportArgs = exportArgs;
    return this;
  }

   /**
   * Replication arguments for the EXPORT operation.
   * @return exportArgs
  **/
  @ApiModelProperty(value = "Replication arguments for the EXPORT operation.")
  public ApiRangerReplicationExportArgs getExportArgs() {
    return exportArgs;
  }

  public void setExportArgs(ApiRangerReplicationExportArgs exportArgs) {
    this.exportArgs = exportArgs;
  }

  public ApiRangerReplicationArgs transformArgs(ApiRangerReplicationTransformArgs transformArgs) {
    this.transformArgs = transformArgs;
    return this;
  }

   /**
   * Replication arguments for the TRANSFORM operation.
   * @return transformArgs
  **/
  @ApiModelProperty(value = "Replication arguments for the TRANSFORM operation.")
  public ApiRangerReplicationTransformArgs getTransformArgs() {
    return transformArgs;
  }

  public void setTransformArgs(ApiRangerReplicationTransformArgs transformArgs) {
    this.transformArgs = transformArgs;
  }

  public ApiRangerReplicationArgs importArgs(ApiRangerReplicationImportArgs importArgs) {
    this.importArgs = importArgs;
    return this;
  }

   /**
   * Replication arguments for the IMPORT operation.
   * @return importArgs
  **/
  @ApiModelProperty(value = "Replication arguments for the IMPORT operation.")
  public ApiRangerReplicationImportArgs getImportArgs() {
    return importArgs;
  }

  public void setImportArgs(ApiRangerReplicationImportArgs importArgs) {
    this.importArgs = importArgs;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiRangerReplicationArgs apiRangerReplicationArgs = (ApiRangerReplicationArgs) o;
    return Objects.equals(this.sourceRangerService, apiRangerReplicationArgs.sourceRangerService) &&
        Objects.equals(this.exportArgs, apiRangerReplicationArgs.exportArgs) &&
        Objects.equals(this.transformArgs, apiRangerReplicationArgs.transformArgs) &&
        Objects.equals(this.importArgs, apiRangerReplicationArgs.importArgs);
  }

  @Override
  public int hashCode() {
    return Objects.hash(sourceRangerService, exportArgs, transformArgs, importArgs);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiRangerReplicationArgs {\n");
    
    sb.append("    sourceRangerService: ").append(toIndentedString(sourceRangerService)).append("\n");
    sb.append("    exportArgs: ").append(toIndentedString(exportArgs)).append("\n");
    sb.append("    transformArgs: ").append(toIndentedString(transformArgs)).append("\n");
    sb.append("    importArgs: ").append(toIndentedString(importArgs)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

