
# ApiHiveReplicationResult

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**phase** | **String** | Phase the replication is in. &lt;p/&gt; If the replication job is still active, this will contain a string describing the current phase. This will be one of: EXPORT, DATA or IMPORT, for, respectively, exporting the source metastore information, replicating table data (if configured), and importing metastore information in the target. &lt;p/&gt; This value will not be present if the replication is not active. &lt;p/&gt; Available since API v4. |  [optional]
**tableCount** | **java.math.BigDecimal** | Number of tables that were successfully replicated. Available since API v4. |  [optional]
**tables** | [**List&lt;ApiHiveTable&gt;**](ApiHiveTable.md) | The list of tables successfully replicated. &lt;p/&gt; Since API v4, this is only available in the full view. |  [optional]
**impalaUDFCount** | **java.math.BigDecimal** | Number of impala UDFs that were successfully replicated. Available since API v6. |  [optional]
**hiveUDFCount** | **java.math.BigDecimal** | Number of hive UDFs that were successfully replicated. Available since API v14. |  [optional]
**impalaUDFs** | [**List&lt;ApiImpalaUDF&gt;**](ApiImpalaUDF.md) | The list of Impala UDFs successfully replicated. Available since API v6 in the full view. |  [optional]
**hiveUDFs** | [**List&lt;ApiHiveUDF&gt;**](ApiHiveUDF.md) | The list of Impala UDFs successfully replicated. Available since API v6 in the full view. |  [optional]
**errorCount** | **java.math.BigDecimal** | Number of errors detected during replication job. Available since API v4. |  [optional]
**errors** | [**List&lt;ApiHiveReplicationError&gt;**](ApiHiveReplicationError.md) | List of errors encountered during replication. &lt;p/&gt; Since API v4, this is only available in the full view. |  [optional]
**dataReplicationResult** | [**ApiHdfsReplicationResult**](ApiHdfsReplicationResult.md) | Result of table data replication, if performed. |  [optional]
**dryRun** | **Boolean** | Whether this was a dry run. |  [optional]
**runAsUser** | **String** | Name of the of proxy user, if any. Available since API v11. |  [optional]
**runOnSourceAsUser** | **String** | Name of the source proxy user, if any. Available since API v18. |  [optional]
**logPath** | **String** | Returns HDFS path of DistCp execution log files. Available since API v33. |  [optional]
**directoryForMetadata** | **String** | Returns HDFS path of export file for Hive replication. Available since API v33. |  [optional]
**statsAvailable** | **Boolean** | Whether stats are available to display or not. Available since API v19. |  [optional]
**dbProcessed** | **java.math.BigDecimal** | Number of Db&#39;s Imported/Exported. Available since API v19. |  [optional]
**tableProcessed** | **java.math.BigDecimal** | Number of Tables Imported/Exported. Available since API v19. |  [optional]
**partitionProcessed** | **java.math.BigDecimal** | Number of Partitions Imported/Exported. Available since API v19. |  [optional]
**functionProcessed** | **java.math.BigDecimal** | Number of Functions Imported/Exported. Available since API v19. |  [optional]
**indexProcessed** | **java.math.BigDecimal** | Number of Indexes Imported/Exported. Available since API v19. |  [optional]
**statsProcessed** | **java.math.BigDecimal** | Number of Table and Partitions Statistics Imported/Exported. Available since API v19. |  [optional]
**dbExpected** | **java.math.BigDecimal** | Number of Db&#39;s Expected. Available since API v19. |  [optional]
**tableExpected** | **java.math.BigDecimal** | Number of Tables Expected. Available since API v19. |  [optional]
**partitionExpected** | **java.math.BigDecimal** | Number of Partitions Expected. Available since API v19. |  [optional]
**functionExpected** | **java.math.BigDecimal** | Number of Functions Expected. Available since API v19. |  [optional]
**indexExpected** | **java.math.BigDecimal** | Number of Indexes Expected. Available since API v19. |  [optional]
**statsExpected** | **java.math.BigDecimal** | Number of Table and Partition Statistics Expected. Available since API v19. |  [optional]



