# ControlPlanesResourceApi

All URIs are relative to *https://localhost/api/v51*

Method | HTTP request | Description
------------- | ------------- | -------------
[**addTags**](ControlPlanesResourceApi.md#addTags) | **PUT** /controlPlanes/{controlPlaneUuid}/tags | Attach tags to the control plane.
[**copyImagesInFeatures**](ControlPlanesResourceApi.md#copyImagesInFeatures) | **POST** /controlPlanes/{controlPlaneUuid}/commands/copyImagesInFeatures | Launches the command to copy images for one or more features (a comma separated list).
[**deleteTags**](ControlPlanesResourceApi.md#deleteTags) | **DELETE** /controlPlanes/{controlPlaneUuid}/tags | Remove the tags associated with the control plane.
[**generateCopyDocker**](ControlPlanesResourceApi.md#generateCopyDocker) | **POST** /controlPlanes/commands/generateCopyDocker | Launches the Generate Copy Docker Script Command.
[**generateExternalVaultSetup**](ControlPlanesResourceApi.md#generateExternalVaultSetup) | **POST** /controlPlanes/commands/generateExternalVaultSetup | Launches the Generate Vault Setup Command command.
[**getControlPlanes**](ControlPlanesResourceApi.md#getControlPlanes) | **GET** /controlPlanes | Current Control Planes.
[**getExperienceCluster**](ControlPlanesResourceApi.md#getExperienceCluster) | **GET** /controlPlanes/{controlPlaneUuid}/getTaggedCluster | The cluster with tags matching this control plane&#39;s UUID, if any.
[**getLogContent**](ControlPlanesResourceApi.md#getLogContent) | **POST** /controlPlanes/fetchResources/{commandId}/logContent | Fetches the log content for the specific command.
[**getManifestJson**](ControlPlanesResourceApi.md#getManifestJson) | **POST** /controlPlanes/fetchResources/manifest.json | Fetches the manifest.
[**installControlPlane**](ControlPlanesResourceApi.md#installControlPlane) | **POST** /controlPlanes/commands/installControlPlane | Launches the install control plane command.
[**installEmbeddedControlPlane**](ControlPlanesResourceApi.md#installEmbeddedControlPlane) | **POST** /controlPlanes/commands/installEmbeddedControlPlane | Brings up a control plane on embedded kubernetes.
[**readControlPlaneByUuid**](ControlPlanesResourceApi.md#readControlPlaneByUuid) | **GET** /controlPlanes/{controlPlaneUuid} | The control plane with the given id.
[**readTags**](ControlPlanesResourceApi.md#readTags) | **GET** /controlPlanes/{controlPlaneUuid}/tags | Returns the tags associated with this control plane.
[**uninstallControlPlane**](ControlPlanesResourceApi.md#uninstallControlPlane) | **POST** /controlPlanes/{controlPlaneUuid}/commands/uninstallControlPlane | Launches Uninstall Command on the control plane with the given uuid.
[**updateValuesYaml**](ControlPlanesResourceApi.md#updateValuesYaml) | **POST** /controlPlanes/{controlPlaneUuid}/commands/updateControlPlaneValuesYaml | Launches update the values.
[**upgradeControlPlane**](ControlPlanesResourceApi.md#upgradeControlPlane) | **POST** /controlPlanes/{controlPlaneUuid}/commands/upgradeControlPlane | Launches the Upgrade Command on the control plane with the given uuid.
[**upgradeEmbeddedControlPlane**](ControlPlanesResourceApi.md#upgradeEmbeddedControlPlane) | **POST** /controlPlanes/commands/upgradeEmbeddedControlPlane | Upgrade a Containerized Cluster, including upgrading the control plane running on embedded kubernetes.


<a name="addTags"></a>
# **addTags**
> List&lt;ApiEntityTag&gt; addTags(controlPlaneUuid, body)

Attach tags to the control plane.

Attach tags to the control plane.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
String controlPlaneUuid = "controlPlaneUuid_example"; // String | The uuid of the control plane.
List<ApiEntityTag> body = Arrays.asList(new ApiEntityTag()); // List<ApiEntityTag> | List of tags to add to the control plane
try {
    List<ApiEntityTag> result = apiInstance.addTags(controlPlaneUuid, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#addTags");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controlPlaneUuid** | **String**| The uuid of the control plane. |
 **body** | [**List&lt;ApiEntityTag&gt;**](ApiEntityTag.md)| List of tags to add to the control plane | [optional]

### Return type

[**List&lt;ApiEntityTag&gt;**](ApiEntityTag.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="copyImagesInFeatures"></a>
# **copyImagesInFeatures**
> ApiCommand copyImagesInFeatures(controlPlaneUuid, body)

Launches the command to copy images for one or more features (a comma separated list).

Launches the command to copy images for one or more features (a comma separated list).

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
String controlPlaneUuid = "controlPlaneUuid_example"; // String | 
ApiCopyImagesInFeaturesArgs body = new ApiCopyImagesInFeaturesArgs(); // ApiCopyImagesInFeaturesArgs | Arguments for the Command
try {
    ApiCommand result = apiInstance.copyImagesInFeatures(controlPlaneUuid, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#copyImagesInFeatures");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controlPlaneUuid** | **String**|  |
 **body** | [**ApiCopyImagesInFeaturesArgs**](ApiCopyImagesInFeaturesArgs.md)| Arguments for the Command | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="deleteTags"></a>
# **deleteTags**
> List&lt;ApiEntityTag&gt; deleteTags(controlPlaneUuid, body)

Remove the tags associated with the control plane.

Remove the tags associated with the control plane

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
String controlPlaneUuid = "controlPlaneUuid_example"; // String | The uuid of the control plane.
List<ApiEntityTag> body = Arrays.asList(new ApiEntityTag()); // List<ApiEntityTag> | A list of tags to remove from the control plane
try {
    List<ApiEntityTag> result = apiInstance.deleteTags(controlPlaneUuid, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#deleteTags");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controlPlaneUuid** | **String**| The uuid of the control plane. |
 **body** | [**List&lt;ApiEntityTag&gt;**](ApiEntityTag.md)| A list of tags to remove from the control plane | [optional]

### Return type

[**List&lt;ApiEntityTag&gt;**](ApiEntityTag.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="generateCopyDocker"></a>
# **generateCopyDocker**
> ApiCommand generateCopyDocker(body)

Launches the Generate Copy Docker Script Command.

Launches the Generate Copy Docker Script Command

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
ApiGenerateCopyDockerArgs body = new ApiGenerateCopyDockerArgs(); // ApiGenerateCopyDockerArgs | Arguments for the Command
try {
    ApiCommand result = apiInstance.generateCopyDocker(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#generateCopyDocker");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApiGenerateCopyDockerArgs**](ApiGenerateCopyDockerArgs.md)| Arguments for the Command | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="generateExternalVaultSetup"></a>
# **generateExternalVaultSetup**
> ApiCommand generateExternalVaultSetup(body)

Launches the Generate Vault Setup Command command.

Launches the Generate Vault Setup Command command

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
ApiGenerateExternalVaultSetupArgs body = new ApiGenerateExternalVaultSetupArgs(); // ApiGenerateExternalVaultSetupArgs | Arguments for the Command
try {
    ApiCommand result = apiInstance.generateExternalVaultSetup(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#generateExternalVaultSetup");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApiGenerateExternalVaultSetupArgs**](ApiGenerateExternalVaultSetupArgs.md)| Arguments for the Command | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getControlPlanes"></a>
# **getControlPlanes**
> ApiControlPlaneList getControlPlanes()

Current Control Planes.

Current Control Planes

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
try {
    ApiControlPlaneList result = apiInstance.getControlPlanes();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#getControlPlanes");
    e.printStackTrace();
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**ApiControlPlaneList**](ApiControlPlaneList.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getExperienceCluster"></a>
# **getExperienceCluster**
> ApiCluster getExperienceCluster(controlPlaneUuid)

The cluster with tags matching this control plane's UUID, if any.

The cluster with tags matching this control plane's UUID, if any

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
String controlPlaneUuid = "controlPlaneUuid_example"; // String | The universally unique id of the control plane
try {
    ApiCluster result = apiInstance.getExperienceCluster(controlPlaneUuid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#getExperienceCluster");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controlPlaneUuid** | **String**| The universally unique id of the control plane |

### Return type

[**ApiCluster**](ApiCluster.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getLogContent"></a>
# **getLogContent**
> File getLogContent(commandId)

Fetches the log content for the specific command.

Fetches the log content for the specific command.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
java.math.BigDecimal commandId = new java.math.BigDecimal(); // java.math.BigDecimal | the command id
try {
    File result = apiInstance.getLogContent(commandId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#getLogContent");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **commandId** | **java.math.BigDecimal**| the command id |

### Return type

[**File**](File.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: text/plain

<a name="getManifestJson"></a>
# **getManifestJson**
> File getManifestJson(body)

Fetches the manifest.

Fetches the manifest.json under the specified remote repo.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
ApiRemoteRepoUrl body = new ApiRemoteRepoUrl(); // ApiRemoteRepoUrl | the remote repo url.
try {
    File result = apiInstance.getManifestJson(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#getManifestJson");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApiRemoteRepoUrl**](ApiRemoteRepoUrl.md)| the remote repo url. | [optional]

### Return type

[**File**](File.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="installControlPlane"></a>
# **installControlPlane**
> ApiCommand installControlPlane(body)

Launches the install control plane command.

Launches the install control plane command.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
ApiInstallControlPlaneArgs body = new ApiInstallControlPlaneArgs(); // ApiInstallControlPlaneArgs | Arguments for the Command
try {
    ApiCommand result = apiInstance.installControlPlane(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#installControlPlane");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApiInstallControlPlaneArgs**](ApiInstallControlPlaneArgs.md)| Arguments for the Command | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="installEmbeddedControlPlane"></a>
# **installEmbeddedControlPlane**
> ApiCommand installEmbeddedControlPlane(body)

Brings up a control plane on embedded kubernetes.

Brings up a control plane on embedded kubernetes. At its core, this command launches the FirstRun command on the Containerized Cluster.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
ApiInstallEmbeddedControlPlaneArgs body = new ApiInstallEmbeddedControlPlaneArgs(); // ApiInstallEmbeddedControlPlaneArgs | The arguments for Ek8s control plane installation
try {
    ApiCommand result = apiInstance.installEmbeddedControlPlane(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#installEmbeddedControlPlane");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApiInstallEmbeddedControlPlaneArgs**](ApiInstallEmbeddedControlPlaneArgs.md)| The arguments for Ek8s control plane installation | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="readControlPlaneByUuid"></a>
# **readControlPlaneByUuid**
> ApiControlPlane readControlPlaneByUuid(controlPlaneUuid)

The control plane with the given id.

The control plane with the given id

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
String controlPlaneUuid = "controlPlaneUuid_example"; // String | The universally unique id of the control plane
try {
    ApiControlPlane result = apiInstance.readControlPlaneByUuid(controlPlaneUuid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#readControlPlaneByUuid");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controlPlaneUuid** | **String**| The universally unique id of the control plane |

### Return type

[**ApiControlPlane**](ApiControlPlane.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="readTags"></a>
# **readTags**
> List&lt;ApiEntityTag&gt; readTags(controlPlaneUuid, limit, offset)

Returns the tags associated with this control plane.

Returns the tags associated with this control plane.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
String controlPlaneUuid = "controlPlaneUuid_example"; // String | The uuid of the control plane.
java.math.BigDecimal limit = new java.math.BigDecimal(); // java.math.BigDecimal | Number of tags
java.math.BigDecimal offset = new java.math.BigDecimal(); // java.math.BigDecimal | Index of the first tag to retrieve
try {
    List<ApiEntityTag> result = apiInstance.readTags(controlPlaneUuid, limit, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#readTags");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controlPlaneUuid** | **String**| The uuid of the control plane. |
 **limit** | **java.math.BigDecimal**| Number of tags | [optional] [default to 10]
 **offset** | **java.math.BigDecimal**| Index of the first tag to retrieve | [optional] [default to 0]

### Return type

[**List&lt;ApiEntityTag&gt;**](ApiEntityTag.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="uninstallControlPlane"></a>
# **uninstallControlPlane**
> ApiCommand uninstallControlPlane(controlPlaneUuid, body)

Launches Uninstall Command on the control plane with the given uuid.

Launches Uninstall Command on the control plane with the given uuid

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
String controlPlaneUuid = "controlPlaneUuid_example"; // String | The universally unique id of the control plane
ApiUninstallControlPlaneArgs body = new ApiUninstallControlPlaneArgs(); // ApiUninstallControlPlaneArgs | Arguments for the Command
try {
    ApiCommand result = apiInstance.uninstallControlPlane(controlPlaneUuid, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#uninstallControlPlane");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controlPlaneUuid** | **String**| The universally unique id of the control plane |
 **body** | [**ApiUninstallControlPlaneArgs**](ApiUninstallControlPlaneArgs.md)| Arguments for the Command | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateValuesYaml"></a>
# **updateValuesYaml**
> ApiCommand updateValuesYaml(controlPlaneUuid, body)

Launches update the values.

Launches update the values.yaml from the control plane with the given uuid This updates the content of values.yaml.merged in the CM database.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
String controlPlaneUuid = "controlPlaneUuid_example"; // String | The universally unique id of the control plane
ApiUpdateControlPlaneValuesYamlArgs body = new ApiUpdateControlPlaneValuesYamlArgs(); // ApiUpdateControlPlaneValuesYamlArgs | Arguments for the Command
try {
    ApiCommand result = apiInstance.updateValuesYaml(controlPlaneUuid, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#updateValuesYaml");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controlPlaneUuid** | **String**| The universally unique id of the control plane |
 **body** | [**ApiUpdateControlPlaneValuesYamlArgs**](ApiUpdateControlPlaneValuesYamlArgs.md)| Arguments for the Command | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="upgradeControlPlane"></a>
# **upgradeControlPlane**
> ApiCommand upgradeControlPlane(controlPlaneUuid, body)

Launches the Upgrade Command on the control plane with the given uuid.

Launches the Upgrade Command on the control plane with the given uuid

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
String controlPlaneUuid = "controlPlaneUuid_example"; // String | The universally unique id of the control plane
ApiUpgradeControlPlaneArgs body = new ApiUpgradeControlPlaneArgs(); // ApiUpgradeControlPlaneArgs | Arguments for the Command
try {
    ApiCommand result = apiInstance.upgradeControlPlane(controlPlaneUuid, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#upgradeControlPlane");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **controlPlaneUuid** | **String**| The universally unique id of the control plane |
 **body** | [**ApiUpgradeControlPlaneArgs**](ApiUpgradeControlPlaneArgs.md)| Arguments for the Command | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="upgradeEmbeddedControlPlane"></a>
# **upgradeEmbeddedControlPlane**
> ApiCommand upgradeEmbeddedControlPlane(body)

Upgrade a Containerized Cluster, including upgrading the control plane running on embedded kubernetes.

Upgrade a Containerized Cluster, including upgrading the control plane running on embedded kubernetes.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ControlPlanesResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ControlPlanesResourceApi apiInstance = new ControlPlanesResourceApi();
ApiUpgradeEmbeddedControlPlaneArgs body = new ApiUpgradeEmbeddedControlPlaneArgs(); // ApiUpgradeEmbeddedControlPlaneArgs | The arguments for Ek8s control plane upgrade
try {
    ApiCommand result = apiInstance.upgradeEmbeddedControlPlane(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ControlPlanesResourceApi#upgradeEmbeddedControlPlane");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApiUpgradeEmbeddedControlPlaneArgs**](ApiUpgradeEmbeddedControlPlaneArgs.md)| The arguments for Ek8s control plane upgrade | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

