/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.0</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.9.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.cloudera.api.swagger.model.ApiHdfsFile;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * An HDFS Snapshottable Directory descriptor.
 */
@ApiModel(description = "An HDFS Snapshottable Directory descriptor.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2022-12-13T14:13:22.839Z")
public class ApiHdfsSnapshottableDirectoryStatus {
  @SerializedName("snapshotNumber")
  private java.math.BigDecimal snapshotNumber = null;

  @SerializedName("snapshotQuota")
  private java.math.BigDecimal snapshotQuota = null;

  @SerializedName("parentFullPath")
  private String parentFullPath = null;

  @SerializedName("dirStatus")
  private ApiHdfsFile dirStatus = null;

  @SerializedName("absolutePath")
  private String absolutePath = null;

  public ApiHdfsSnapshottableDirectoryStatus snapshotNumber(java.math.BigDecimal snapshotNumber) {
    this.snapshotNumber = snapshotNumber;
    return this;
  }

   /**
   * Count of snapshots that have been taken for the directory
   * @return snapshotNumber
  **/
  @ApiModelProperty(required = true, value = "Count of snapshots that have been taken for the directory")
  public java.math.BigDecimal getSnapshotNumber() {
    return snapshotNumber;
  }

  public void setSnapshotNumber(java.math.BigDecimal snapshotNumber) {
    this.snapshotNumber = snapshotNumber;
  }

  public ApiHdfsSnapshottableDirectoryStatus snapshotQuota(java.math.BigDecimal snapshotQuota) {
    this.snapshotQuota = snapshotQuota;
    return this;
  }

   /**
   * Number of snapshots allowed for the directory
   * @return snapshotQuota
  **/
  @ApiModelProperty(required = true, value = "Number of snapshots allowed for the directory")
  public java.math.BigDecimal getSnapshotQuota() {
    return snapshotQuota;
  }

  public void setSnapshotQuota(java.math.BigDecimal snapshotQuota) {
    this.snapshotQuota = snapshotQuota;
  }

  public ApiHdfsSnapshottableDirectoryStatus parentFullPath(String parentFullPath) {
    this.parentFullPath = parentFullPath;
    return this;
  }

   /**
   * Absolute path of the parent
   * @return parentFullPath
  **/
  @ApiModelProperty(value = "Absolute path of the parent")
  public String getParentFullPath() {
    return parentFullPath;
  }

  public void setParentFullPath(String parentFullPath) {
    this.parentFullPath = parentFullPath;
  }

  public ApiHdfsSnapshottableDirectoryStatus dirStatus(ApiHdfsFile dirStatus) {
    this.dirStatus = dirStatus;
    return this;
  }

   /**
   * The basic information of the directory
   * @return dirStatus
  **/
  @ApiModelProperty(value = "The basic information of the directory")
  public ApiHdfsFile getDirStatus() {
    return dirStatus;
  }

  public void setDirStatus(ApiHdfsFile dirStatus) {
    this.dirStatus = dirStatus;
  }

  public ApiHdfsSnapshottableDirectoryStatus absolutePath(String absolutePath) {
    this.absolutePath = absolutePath;
    return this;
  }

   /**
   * Absolute path of the file
   * @return absolutePath
  **/
  @ApiModelProperty(value = "Absolute path of the file")
  public String getAbsolutePath() {
    return absolutePath;
  }

  public void setAbsolutePath(String absolutePath) {
    this.absolutePath = absolutePath;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiHdfsSnapshottableDirectoryStatus apiHdfsSnapshottableDirectoryStatus = (ApiHdfsSnapshottableDirectoryStatus) o;
    return Objects.equals(this.snapshotNumber, apiHdfsSnapshottableDirectoryStatus.snapshotNumber) &&
        Objects.equals(this.snapshotQuota, apiHdfsSnapshottableDirectoryStatus.snapshotQuota) &&
        Objects.equals(this.parentFullPath, apiHdfsSnapshottableDirectoryStatus.parentFullPath) &&
        Objects.equals(this.dirStatus, apiHdfsSnapshottableDirectoryStatus.dirStatus) &&
        Objects.equals(this.absolutePath, apiHdfsSnapshottableDirectoryStatus.absolutePath);
  }

  @Override
  public int hashCode() {
    return Objects.hash(snapshotNumber, snapshotQuota, parentFullPath, dirStatus, absolutePath);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiHdfsSnapshottableDirectoryStatus {\n");
    
    sb.append("    snapshotNumber: ").append(toIndentedString(snapshotNumber)).append("\n");
    sb.append("    snapshotQuota: ").append(toIndentedString(snapshotQuota)).append("\n");
    sb.append("    parentFullPath: ").append(toIndentedString(parentFullPath)).append("\n");
    sb.append("    dirStatus: ").append(toIndentedString(dirStatus)).append("\n");
    sb.append("    absolutePath: ").append(toIndentedString(absolutePath)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

