/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.0</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.9.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.cloudera.api.swagger.model.ApiEndPoint;
import com.cloudera.api.swagger.model.ApiMapEntry;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * This object contains enough information for a Workload cluster to connect to an SDX cluster. This object contains no secrets.
 */
@ApiModel(description = "This object contains enough information for a Workload cluster to connect to an SDX cluster. This object contains no secrets.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2022-12-13T14:13:22.839Z")
public class ApiRemoteDataContext {
  @SerializedName("endPointId")
  private String endPointId = null;

  @SerializedName("endPoints")
  private List<ApiEndPoint> endPoints = null;

  @SerializedName("configs")
  private List<ApiMapEntry> configs = null;

  @SerializedName("clusterVersion")
  private String clusterVersion = null;

  public ApiRemoteDataContext endPointId(String endPointId) {
    this.endPointId = endPointId;
    return this;
  }

   /**
   * A string to uniquely identify the SDX cluster.
   * @return endPointId
  **/
  @ApiModelProperty(value = "A string to uniquely identify the SDX cluster.")
  public String getEndPointId() {
    return endPointId;
  }

  public void setEndPointId(String endPointId) {
    this.endPointId = endPointId;
  }

  public ApiRemoteDataContext endPoints(List<ApiEndPoint> endPoints) {
    this.endPoints = endPoints;
    return this;
  }

  public ApiRemoteDataContext addEndPointsItem(ApiEndPoint endPointsItem) {
    if (this.endPoints == null) {
      this.endPoints = new ArrayList<ApiEndPoint>();
    }
    this.endPoints.add(endPointsItem);
    return this;
  }

   /**
   * List of endPoints exported by this SDX cluster.
   * @return endPoints
  **/
  @ApiModelProperty(value = "List of endPoints exported by this SDX cluster.")
  public List<ApiEndPoint> getEndPoints() {
    return endPoints;
  }

  public void setEndPoints(List<ApiEndPoint> endPoints) {
    this.endPoints = endPoints;
  }

  public ApiRemoteDataContext configs(List<ApiMapEntry> configs) {
    this.configs = configs;
    return this;
  }

  public ApiRemoteDataContext addConfigsItem(ApiMapEntry configsItem) {
    if (this.configs == null) {
      this.configs = new ArrayList<ApiMapEntry>();
    }
    this.configs.add(configsItem);
    return this;
  }

   /**
   * SDX cluster specifc options.
   * @return configs
  **/
  @ApiModelProperty(value = "SDX cluster specifc options.")
  public List<ApiMapEntry> getConfigs() {
    return configs;
  }

  public void setConfigs(List<ApiMapEntry> configs) {
    this.configs = configs;
  }

  public ApiRemoteDataContext clusterVersion(String clusterVersion) {
    this.clusterVersion = clusterVersion;
    return this;
  }

   /**
   * Cluster version
   * @return clusterVersion
  **/
  @ApiModelProperty(value = "Cluster version")
  public String getClusterVersion() {
    return clusterVersion;
  }

  public void setClusterVersion(String clusterVersion) {
    this.clusterVersion = clusterVersion;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiRemoteDataContext apiRemoteDataContext = (ApiRemoteDataContext) o;
    return Objects.equals(this.endPointId, apiRemoteDataContext.endPointId) &&
        Objects.equals(this.endPoints, apiRemoteDataContext.endPoints) &&
        Objects.equals(this.configs, apiRemoteDataContext.configs) &&
        Objects.equals(this.clusterVersion, apiRemoteDataContext.clusterVersion);
  }

  @Override
  public int hashCode() {
    return Objects.hash(endPointId, endPoints, configs, clusterVersion);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiRemoteDataContext {\n");
    
    sb.append("    endPointId: ").append(toIndentedString(endPointId)).append("\n");
    sb.append("    endPoints: ").append(toIndentedString(endPoints)).append("\n");
    sb.append("    configs: ").append(toIndentedString(configs)).append("\n");
    sb.append("    clusterVersion: ").append(toIndentedString(clusterVersion)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

