# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.0</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>

    OpenAPI spec version: 7.9.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ApiClusterSupportToken(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cluster_name': 'str',
        'display_name': 'str',
        'cluster_support_token': 'str'
    }

    attribute_map = {
        'cluster_name': 'clusterName',
        'display_name': 'displayName',
        'cluster_support_token': 'clusterSupportToken'
    }

    def __init__(self, cluster_name=None, display_name=None, cluster_support_token=None):
        """
        ApiClusterSupportToken - a model defined in Swagger
        """

        self._cluster_name = None
        self._display_name = None
        self._cluster_support_token = None

        if cluster_name is not None:
          self.cluster_name = cluster_name
        if display_name is not None:
          self.display_name = display_name
        if cluster_support_token is not None:
          self.cluster_support_token = cluster_support_token

    @property
    def cluster_name(self):
        """
        Gets the cluster_name of this ApiClusterSupportToken.
        The name of the cluster. <p> Immutable since API v6. <p> Prior to API v6, will contain the display name of the cluster.

        :return: The cluster_name of this ApiClusterSupportToken.
        :rtype: str
        """
        return self._cluster_name

    @cluster_name.setter
    def cluster_name(self, cluster_name):
        """
        Sets the cluster_name of this ApiClusterSupportToken.
        The name of the cluster. <p> Immutable since API v6. <p> Prior to API v6, will contain the display name of the cluster.

        :param cluster_name: The cluster_name of this ApiClusterSupportToken.
        :type: str
        """

        self._cluster_name = cluster_name

    @property
    def display_name(self):
        """
        Gets the display_name of this ApiClusterSupportToken.
        The display name of the cluster that is shown in the UI. <p> Available since API v6.

        :return: The display_name of this ApiClusterSupportToken.
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """
        Sets the display_name of this ApiClusterSupportToken.
        The display name of the cluster that is shown in the UI. <p> Available since API v6.

        :param display_name: The display_name of this ApiClusterSupportToken.
        :type: str
        """

        self._display_name = display_name

    @property
    def cluster_support_token(self):
        """
        Gets the cluster_support_token of this ApiClusterSupportToken.
        The unique support token for a cluster. <p> Available since API v43.

        :return: The cluster_support_token of this ApiClusterSupportToken.
        :rtype: str
        """
        return self._cluster_support_token

    @cluster_support_token.setter
    def cluster_support_token(self, cluster_support_token):
        """
        Sets the cluster_support_token of this ApiClusterSupportToken.
        The unique support token for a cluster. <p> Available since API v43.

        :param cluster_support_token: The cluster_support_token of this ApiClusterSupportToken.
        :type: str
        """

        self._cluster_support_token = cluster_support_token

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ApiClusterSupportToken):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
