# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.0</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>

    OpenAPI spec version: 7.9.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ApiHdfsFile(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'absolute_path': 'str',
        'length': 'int',
        'dir': 'bool',
        'replication': 'float',
        'block_size': 'int',
        'modification_time': 'str',
        'access_time': 'str',
        'permission': 'float',
        'owner': 'str',
        'group': 'str'
    }

    attribute_map = {
        'absolute_path': 'absolutePath',
        'length': 'length',
        'dir': 'dir',
        'replication': 'replication',
        'block_size': 'blockSize',
        'modification_time': 'modificationTime',
        'access_time': 'accessTime',
        'permission': 'permission',
        'owner': 'owner',
        'group': 'group'
    }

    def __init__(self, absolute_path=None, length=None, dir=None, replication=None, block_size=None, modification_time=None, access_time=None, permission=None, owner=None, group=None):
        """
        ApiHdfsFile - a model defined in Swagger
        """

        self._absolute_path = None
        self._length = None
        self._dir = None
        self._replication = None
        self._block_size = None
        self._modification_time = None
        self._access_time = None
        self._permission = None
        self._owner = None
        self._group = None

        if absolute_path is not None:
          self.absolute_path = absolute_path
        self.length = length
        self.dir = dir
        self.replication = replication
        self.block_size = block_size
        if modification_time is not None:
          self.modification_time = modification_time
        if access_time is not None:
          self.access_time = access_time
        self.permission = permission
        if owner is not None:
          self.owner = owner
        if group is not None:
          self.group = group

    @property
    def absolute_path(self):
        """
        Gets the absolute_path of this ApiHdfsFile.
        Fully qualified path of file.

        :return: The absolute_path of this ApiHdfsFile.
        :rtype: str
        """
        return self._absolute_path

    @absolute_path.setter
    def absolute_path(self, absolute_path):
        """
        Sets the absolute_path of this ApiHdfsFile.
        Fully qualified path of file.

        :param absolute_path: The absolute_path of this ApiHdfsFile.
        :type: str
        """

        self._absolute_path = absolute_path

    @property
    def length(self):
        """
        Gets the length of this ApiHdfsFile.
        Size of file.

        :return: The length of this ApiHdfsFile.
        :rtype: int
        """
        return self._length

    @length.setter
    def length(self, length):
        """
        Sets the length of this ApiHdfsFile.
        Size of file.

        :param length: The length of this ApiHdfsFile.
        :type: int
        """
        if length is None:
            raise ValueError("Invalid value for `length`, must not be `None`")

        self._length = length

    @property
    def dir(self):
        """
        Gets the dir of this ApiHdfsFile.
        Indicates whether the file is a directory.

        :return: The dir of this ApiHdfsFile.
        :rtype: bool
        """
        return self._dir

    @dir.setter
    def dir(self, dir):
        """
        Sets the dir of this ApiHdfsFile.
        Indicates whether the file is a directory.

        :param dir: The dir of this ApiHdfsFile.
        :type: bool
        """
        if dir is None:
            raise ValueError("Invalid value for `dir`, must not be `None`")

        self._dir = dir

    @property
    def replication(self):
        """
        Gets the replication of this ApiHdfsFile.
        Configured block replication factor of file.

        :return: The replication of this ApiHdfsFile.
        :rtype: float
        """
        return self._replication

    @replication.setter
    def replication(self, replication):
        """
        Sets the replication of this ApiHdfsFile.
        Configured block replication factor of file.

        :param replication: The replication of this ApiHdfsFile.
        :type: float
        """
        if replication is None:
            raise ValueError("Invalid value for `replication`, must not be `None`")

        self._replication = replication

    @property
    def block_size(self):
        """
        Gets the block_size of this ApiHdfsFile.
        Configured block size of file in bytes.

        :return: The block_size of this ApiHdfsFile.
        :rtype: int
        """
        return self._block_size

    @block_size.setter
    def block_size(self, block_size):
        """
        Sets the block_size of this ApiHdfsFile.
        Configured block size of file in bytes.

        :param block_size: The block_size of this ApiHdfsFile.
        :type: int
        """
        if block_size is None:
            raise ValueError("Invalid value for `block_size`, must not be `None`")

        self._block_size = block_size

    @property
    def modification_time(self):
        """
        Gets the modification_time of this ApiHdfsFile.
        Last modification time of file in milliseconds since January 1, 1970 UTC.

        :return: The modification_time of this ApiHdfsFile.
        :rtype: str
        """
        return self._modification_time

    @modification_time.setter
    def modification_time(self, modification_time):
        """
        Sets the modification_time of this ApiHdfsFile.
        Last modification time of file in milliseconds since January 1, 1970 UTC.

        :param modification_time: The modification_time of this ApiHdfsFile.
        :type: str
        """

        self._modification_time = modification_time

    @property
    def access_time(self):
        """
        Gets the access_time of this ApiHdfsFile.
        Last access time of file in milliseconds since January 1, 1970 UTC.

        :return: The access_time of this ApiHdfsFile.
        :rtype: str
        """
        return self._access_time

    @access_time.setter
    def access_time(self, access_time):
        """
        Sets the access_time of this ApiHdfsFile.
        Last access time of file in milliseconds since January 1, 1970 UTC.

        :param access_time: The access_time of this ApiHdfsFile.
        :type: str
        """

        self._access_time = access_time

    @property
    def permission(self):
        """
        Gets the permission of this ApiHdfsFile.
        Permission of the file where the digits in order represent: Sticky bit, User action, Group action, Other action.

        :return: The permission of this ApiHdfsFile.
        :rtype: float
        """
        return self._permission

    @permission.setter
    def permission(self, permission):
        """
        Sets the permission of this ApiHdfsFile.
        Permission of the file where the digits in order represent: Sticky bit, User action, Group action, Other action.

        :param permission: The permission of this ApiHdfsFile.
        :type: float
        """
        if permission is None:
            raise ValueError("Invalid value for `permission`, must not be `None`")

        self._permission = permission

    @property
    def owner(self):
        """
        Gets the owner of this ApiHdfsFile.
        Owner of the file.

        :return: The owner of this ApiHdfsFile.
        :rtype: str
        """
        return self._owner

    @owner.setter
    def owner(self, owner):
        """
        Sets the owner of this ApiHdfsFile.
        Owner of the file.

        :param owner: The owner of this ApiHdfsFile.
        :type: str
        """

        self._owner = owner

    @property
    def group(self):
        """
        Gets the group of this ApiHdfsFile.
        Group of the file.

        :return: The group of this ApiHdfsFile.
        :rtype: str
        """
        return self._group

    @group.setter
    def group(self, group):
        """
        Sets the group of this ApiHdfsFile.
        Group of the file.

        :param group: The group of this ApiHdfsFile.
        :type: str
        """

        self._group = group

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ApiHdfsFile):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
