# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.0</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>

    OpenAPI spec version: 7.9.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ApiHdfsSnapshottableDirectoryStatus(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'snapshot_number': 'int',
        'snapshot_quota': 'int',
        'parent_full_path': 'str',
        'dir_status': 'ApiHdfsFile',
        'absolute_path': 'str'
    }

    attribute_map = {
        'snapshot_number': 'snapshotNumber',
        'snapshot_quota': 'snapshotQuota',
        'parent_full_path': 'parentFullPath',
        'dir_status': 'dirStatus',
        'absolute_path': 'absolutePath'
    }

    def __init__(self, snapshot_number=None, snapshot_quota=None, parent_full_path=None, dir_status=None, absolute_path=None):
        """
        ApiHdfsSnapshottableDirectoryStatus - a model defined in Swagger
        """

        self._snapshot_number = None
        self._snapshot_quota = None
        self._parent_full_path = None
        self._dir_status = None
        self._absolute_path = None

        self.snapshot_number = snapshot_number
        self.snapshot_quota = snapshot_quota
        if parent_full_path is not None:
          self.parent_full_path = parent_full_path
        if dir_status is not None:
          self.dir_status = dir_status
        if absolute_path is not None:
          self.absolute_path = absolute_path

    @property
    def snapshot_number(self):
        """
        Gets the snapshot_number of this ApiHdfsSnapshottableDirectoryStatus.
        Count of snapshots that have been taken for the directory

        :return: The snapshot_number of this ApiHdfsSnapshottableDirectoryStatus.
        :rtype: int
        """
        return self._snapshot_number

    @snapshot_number.setter
    def snapshot_number(self, snapshot_number):
        """
        Sets the snapshot_number of this ApiHdfsSnapshottableDirectoryStatus.
        Count of snapshots that have been taken for the directory

        :param snapshot_number: The snapshot_number of this ApiHdfsSnapshottableDirectoryStatus.
        :type: int
        """
        if snapshot_number is None:
            raise ValueError("Invalid value for `snapshot_number`, must not be `None`")

        self._snapshot_number = snapshot_number

    @property
    def snapshot_quota(self):
        """
        Gets the snapshot_quota of this ApiHdfsSnapshottableDirectoryStatus.
        Number of snapshots allowed for the directory

        :return: The snapshot_quota of this ApiHdfsSnapshottableDirectoryStatus.
        :rtype: int
        """
        return self._snapshot_quota

    @snapshot_quota.setter
    def snapshot_quota(self, snapshot_quota):
        """
        Sets the snapshot_quota of this ApiHdfsSnapshottableDirectoryStatus.
        Number of snapshots allowed for the directory

        :param snapshot_quota: The snapshot_quota of this ApiHdfsSnapshottableDirectoryStatus.
        :type: int
        """
        if snapshot_quota is None:
            raise ValueError("Invalid value for `snapshot_quota`, must not be `None`")

        self._snapshot_quota = snapshot_quota

    @property
    def parent_full_path(self):
        """
        Gets the parent_full_path of this ApiHdfsSnapshottableDirectoryStatus.
        Absolute path of the parent

        :return: The parent_full_path of this ApiHdfsSnapshottableDirectoryStatus.
        :rtype: str
        """
        return self._parent_full_path

    @parent_full_path.setter
    def parent_full_path(self, parent_full_path):
        """
        Sets the parent_full_path of this ApiHdfsSnapshottableDirectoryStatus.
        Absolute path of the parent

        :param parent_full_path: The parent_full_path of this ApiHdfsSnapshottableDirectoryStatus.
        :type: str
        """

        self._parent_full_path = parent_full_path

    @property
    def dir_status(self):
        """
        Gets the dir_status of this ApiHdfsSnapshottableDirectoryStatus.
        The basic information of the directory

        :return: The dir_status of this ApiHdfsSnapshottableDirectoryStatus.
        :rtype: ApiHdfsFile
        """
        return self._dir_status

    @dir_status.setter
    def dir_status(self, dir_status):
        """
        Sets the dir_status of this ApiHdfsSnapshottableDirectoryStatus.
        The basic information of the directory

        :param dir_status: The dir_status of this ApiHdfsSnapshottableDirectoryStatus.
        :type: ApiHdfsFile
        """

        self._dir_status = dir_status

    @property
    def absolute_path(self):
        """
        Gets the absolute_path of this ApiHdfsSnapshottableDirectoryStatus.
        Absolute path of the file

        :return: The absolute_path of this ApiHdfsSnapshottableDirectoryStatus.
        :rtype: str
        """
        return self._absolute_path

    @absolute_path.setter
    def absolute_path(self, absolute_path):
        """
        Sets the absolute_path of this ApiHdfsSnapshottableDirectoryStatus.
        Absolute path of the file

        :param absolute_path: The absolute_path of this ApiHdfsSnapshottableDirectoryStatus.
        :type: str
        """

        self._absolute_path = absolute_path

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ApiHdfsSnapshottableDirectoryStatus):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
