# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.0</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>

    OpenAPI spec version: 7.9.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ApiRangerReplicationArgs(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'source_ranger_service': 'ApiServiceRef',
        'export_args': 'ApiRangerReplicationExportArgs',
        'transform_args': 'ApiRangerReplicationTransformArgs',
        'import_args': 'ApiRangerReplicationImportArgs'
    }

    attribute_map = {
        'source_ranger_service': 'sourceRangerService',
        'export_args': 'exportArgs',
        'transform_args': 'transformArgs',
        'import_args': 'importArgs'
    }

    def __init__(self, source_ranger_service=None, export_args=None, transform_args=None, import_args=None):
        """
        ApiRangerReplicationArgs - a model defined in Swagger
        """

        self._source_ranger_service = None
        self._export_args = None
        self._transform_args = None
        self._import_args = None

        if source_ranger_service is not None:
          self.source_ranger_service = source_ranger_service
        if export_args is not None:
          self.export_args = export_args
        if transform_args is not None:
          self.transform_args = transform_args
        if import_args is not None:
          self.import_args = import_args

    @property
    def source_ranger_service(self):
        """
        Gets the source_ranger_service of this ApiRangerReplicationArgs.
        The source service to replicate from.

        :return: The source_ranger_service of this ApiRangerReplicationArgs.
        :rtype: ApiServiceRef
        """
        return self._source_ranger_service

    @source_ranger_service.setter
    def source_ranger_service(self, source_ranger_service):
        """
        Sets the source_ranger_service of this ApiRangerReplicationArgs.
        The source service to replicate from.

        :param source_ranger_service: The source_ranger_service of this ApiRangerReplicationArgs.
        :type: ApiServiceRef
        """

        self._source_ranger_service = source_ranger_service

    @property
    def export_args(self):
        """
        Gets the export_args of this ApiRangerReplicationArgs.
        Replication arguments for the EXPORT operation.

        :return: The export_args of this ApiRangerReplicationArgs.
        :rtype: ApiRangerReplicationExportArgs
        """
        return self._export_args

    @export_args.setter
    def export_args(self, export_args):
        """
        Sets the export_args of this ApiRangerReplicationArgs.
        Replication arguments for the EXPORT operation.

        :param export_args: The export_args of this ApiRangerReplicationArgs.
        :type: ApiRangerReplicationExportArgs
        """

        self._export_args = export_args

    @property
    def transform_args(self):
        """
        Gets the transform_args of this ApiRangerReplicationArgs.
        Replication arguments for the TRANSFORM operation.

        :return: The transform_args of this ApiRangerReplicationArgs.
        :rtype: ApiRangerReplicationTransformArgs
        """
        return self._transform_args

    @transform_args.setter
    def transform_args(self, transform_args):
        """
        Sets the transform_args of this ApiRangerReplicationArgs.
        Replication arguments for the TRANSFORM operation.

        :param transform_args: The transform_args of this ApiRangerReplicationArgs.
        :type: ApiRangerReplicationTransformArgs
        """

        self._transform_args = transform_args

    @property
    def import_args(self):
        """
        Gets the import_args of this ApiRangerReplicationArgs.
        Replication arguments for the IMPORT operation.

        :return: The import_args of this ApiRangerReplicationArgs.
        :rtype: ApiRangerReplicationImportArgs
        """
        return self._import_args

    @import_args.setter
    def import_args(self, import_args):
        """
        Sets the import_args of this ApiRangerReplicationArgs.
        Replication arguments for the IMPORT operation.

        :param import_args: The import_args of this ApiRangerReplicationArgs.
        :type: ApiRangerReplicationImportArgs
        """

        self._import_args = import_args

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ApiRangerReplicationArgs):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
