# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.0</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>

    OpenAPI spec version: 7.9.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import os
import sys
import unittest

import cm_client
from cm_client.rest import ApiException
from cm_client.apis.replications_resource_api import ReplicationsResourceApi


class TestReplicationsResourceApi(unittest.TestCase):
    """ ReplicationsResourceApi unit test stubs """

    def setUp(self):
        self.api = cm_client.apis.replications_resource_api.ReplicationsResourceApi()

    def tearDown(self):
        pass

    def test_add_h_base_replication_peer(self):
        """
        Test case for add_h_base_replication_peer

        Starts a command that adds a new replication peer to HBase.
        """
        pass

    def test_add_tables_to_h_base_peer(self):
        """
        Test case for add_tables_to_h_base_peer

        Starts a command that adds tables and column families to an existing HBase replication peer.
        """
        pass

    def test_check_h_base_tables_exist(self):
        """
        Test case for check_h_base_tables_exist

        Starts a command that checks if the specified tables exist in HBase.
        """
        pass

    def test_collect_diagnostic_data(self):
        """
        Test case for collect_diagnostic_data

        Collect diagnostic data for a schedule, optionally for a subset of commands on that schedule, matched by schedule ID.
        """
        pass

    def test_create_cloud_credstore_on_hdfs(self):
        """
        Test case for create_cloud_credstore_on_hdfs

        Creates a credstore provider jceks file on HDFS for the given service.
        """
        pass

    def test_create_credstore(self):
        """
        Test case for create_credstore

        Use the following API endpoint instead:.
        """
        pass

    def test_create_h_base_table(self):
        """
        Test case for create_h_base_table

        Starts a command that creates a new table in HBase.
        """
        pass

    def test_create_schedules(self):
        """
        Test case for create_schedules

        Creates one or more replication schedules.
        """
        pass

    def test_delete_all_schedules(self):
        """
        Test case for delete_all_schedules

        Deletes all existing replication schedules.
        """
        pass

    def test_delete_schedule(self):
        """
        Test case for delete_schedule

        Deletes an existing replication schedule.
        """
        pass

    def test_export_ranger_services(self):
        """
        Test case for export_ranger_services

        Exports the given Ranger services and policies (defined in the API body) to a zipped file.
        """
        pass

    def test_fetch_h_base_column_families(self):
        """
        Test case for fetch_h_base_column_families

        Starts a command that fetches column families for the desired tables.
        """
        pass

    def test_fetch_h_base_peer_info(self):
        """
        Test case for fetch_h_base_peer_info

        Starts a command that fetches information about an HBase peer by its ID.
        """
        pass

    def test_force_delete_schedule(self):
        """
        Test case for force_delete_schedule

        Deletes an existing replication schedule only from the DB.
        """
        pass

    def test_generate_cloud_repl_credstore_password(self):
        """
        Test case for generate_cloud_repl_credstore_password

        (Re)generates the cloud credential provider password, used by the given service, for replicating to the cloud.
        """
        pass

    def test_get_replication_state(self):
        """
        Test case for get_replication_state

        returns the replication state.
        """
        pass

    def test_is_hive3_reverse_direction_enabled(self):
        """
        Test case for is_hive3_reverse_direction_enabled

        This API endpoint checks if there is an ENABLED Hive3 replication policy on this server that replicates for the reverse direction.
        """
        pass

    def test_list_h_base_namespaces(self):
        """
        Test case for list_h_base_namespaces

        Starts a command that lists all namespaces in HBase.
        """
        pass

    def test_list_h_base_peers(self):
        """
        Test case for list_h_base_peers

        Starts a command that retrieves all peers registered in the HBase service.
        """
        pass

    def test_list_h_base_tables(self):
        """
        Test case for list_h_base_tables

        Starts a command that lists tables from the HBase service.
        """
        pass

    def test_read_history(self):
        """
        Test case for read_history

        Returns a list of commands triggered by a schedule.
        """
        pass

    def test_read_schedule(self):
        """
        Test case for read_schedule

        Returns information for a specific replication schedule.
        """
        pass

    def test_read_schedules(self):
        """
        Test case for read_schedules

        Retrieves information about replication schedules.
        """
        pass

    def test_recreate_cloud_credstores_on_hdfs(self):
        """
        Test case for recreate_cloud_credstores_on_hdfs

        Recreates the existing credential provider jceks files on HDFS, that are used by the given service, for replicating to the cloud.
        """
        pass

    def test_remove_h_base_peer(self):
        """
        Test case for remove_h_base_peer

        Starts a command that removes the specified HBase replication peer from the local HBase service.
        """
        pass

    def test_remove_tables_from_h_base_peer(self):
        """
        Test case for remove_tables_from_h_base_peer

        Starts a command that removes tables and column families from an existing HBase replication peer.
        """
        pass

    def test_reschedule_hive3_replication_metrics_getter(self):
        """
        Test case for reschedule_hive3_replication_metrics_getter

        Set the Hive3 Replication Metrics Getter next start time.
        """
        pass

    def test_run_copy_listing(self):
        """
        Test case for run_copy_listing

        Run the hdfs copy listing command.
        """
        pass

    def test_run_h_base_replication_retry_failed_snapshots(self):
        """
        Test case for run_h_base_replication_retry_failed_snapshots

        Executes a command to run a HBase replication retry on failed snapshots for the given schedule ID.
        """
        pass

    def test_run_h_base_replication_security_tool(self):
        """
        Test case for run_h_base_replication_security_tool

        Run the hbase replication security tool.
        """
        pass

    def test_run_h_base_replication_validation_tool(self):
        """
        Test case for run_h_base_replication_validation_tool

        Executes a command, which validates if HBase replication works properly for the given hbasePeerId.
        """
        pass

    def test_run_hive_replication_query(self):
        """
        Test case for run_hive_replication_query

        Execute a hive replication query on local HS2 service instance.
        """
        pass

    def test_run_schedule(self):
        """
        Test case for run_schedule

        Run the schedule immediately.
        """
        pass

    def test_set_c_fs_replication_scope(self):
        """
        Test case for set_c_fs_replication_scope

        Starts a command that set the replication scope of the provided column families to the desired value.
        """
        pass

    def test_update_h_base_peer_state(self):
        """
        Test case for update_h_base_peer_state

        Update HBase peer state ('DISABLE' or 'ENABLE'),.
        """
        pass

    def test_update_h_base_replication_peer_state(self):
        """
        Test case for update_h_base_replication_peer_state

        Starts a command that updates the state of an existing HBase replication peer.
        """
        pass

    def test_update_schedule(self):
        """
        Test case for update_schedule

        Updates an existing replication schedule.
        """
        pass


if __name__ == '__main__':
    unittest.main()
